<schema xmlns="http://purl.oclc.org/dsdl/schematron"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<ns uri="http://www.w3.org/2000/09/xmldsig#" prefix="ns2"/>
	<ns uri="http://www.w3.org/2001/XMLSchema-instance" prefix="xsi"/>
	<title>TFP Schematron Validator Sample</title>
	<pattern>
		<rule context="fee[rt = 'S']">
			<let name="n" value="1 + count(preceding-sibling::fee[rt = 'S'])"/>
			<assert test="startDate and not(startDate = '')"
				>ERR: No startDate in S record <xsl:value-of select="$n"/>
			</assert>
			<assert test="not(yearMonth)"
				>WARN: yearMonth is not meaningful in S record <xsl:value-of select="$n"/>
			</assert>
			<assert test="not(avgMakeFee|avgTakeFee|medianMakeFee|medianTakeFee)"
				>WARN: average and median fees are not meaningful in S record <xsl:value-of select="$n"/>
			</assert>
		</rule>
		<rule context="fee[rt = 'M']">
			<let name="n" value="1 + count(preceding-sibling::fee[rt = 'M'])"/>
			<assert test="yearMonth and not(yearMonth = '')" 
				>ERR: No yearMonth in M Record <value-of select="$n"/>
			</assert>
			<assert
				test="(avgTakeFee and not(avgTakeFee = ''))
					or (avgMakeFee and not(avgMakeFee = ''))
					or (medianTakeFee and not(medianTakeFee = ''))
					or (medianMakeFee and not(medianMakeFee = ''))"
				>ERR: No average or median fees in M record <value-of select="$n"/>
			</assert>
		</rule>
	</pattern>
	<pattern>
		<rule context="fee[position() = last()]">
			<let name="n" value="1 + count(preceding-sibling::fee)"/>
			<report test="true()">INFO: Done checking <value-of select="$n"/> records.</report>
		</rule>
	</pattern>
</schema>
